
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>python struct模块 / 憋错料</title>

    <meta name="description" content="python struct模块 一.简介 了解c语言的人,一定会知道struct结构体在c语言中的作用,它定义了一种结构,里面包含不同类型的数据(int, char, bool等等),方便对某一结构对象进行处理.而在网络通信当中,大多传递的数据是以二进制流(binary data)存在的.当传递字符串时,不必担心太多的问题,而当传递诸如int.char之类的基本数据的时候,就需要有一种机制将某些特定的结构体类型打包成二进制流的字符串然后再网络传输,而接收端也应该可以通过某种机制进行解包还原出原始的结构体数据.python中的s">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">python struct模块</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、简介</p>
<p>了解c语言的人，一定会知道struct结构体在c语言中的作用，它定义了一种结构，里面包含不同类型的数据(int, char, bool等等)，方便对某一结构对象进行处理。而在网络通信当中，大多传递的数据是以二进制流(binary data)存在的。当传递字符串时，不必担心太多的问题，而当传递诸如int、char之类的基本数据的时候，就需要有一种机制将某些特定的结构体类型打包成二进制流的字符串然后再网络传输，而接收端也应该可以通过某种机制进行解包还原出原始的结构体数据。python中的struct模块就提供了这样的机制，该模块的主要作用就是对python基本类型值与用python字符串格式表示的C struct类型间的转化。</p>
<p>二、使用</p>
<p><strong></strong><strong>1、 基本的pack和unpack</strong><strong></strong></p>
<p>struct提供用format specifier方式对数据进行打包和解包（Packing and Unpacking）。例如:</p>
<pre>import&nbsp;struct
import&nbsp;binasciivalues&nbsp;=&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.7)
s&nbsp;=&nbsp;struct.Struct(‘I3sf‘)
packed_data&nbsp;=&nbsp;s.pack(*values)
unpacked_data&nbsp;=&nbsp;s.unpack(packed_data)
print&nbsp;‘Original&nbsp;values:‘,&nbsp;values
print&nbsp;‘Format&nbsp;string&nbsp;:‘,&nbsp;s.format
print&nbsp;‘Uses&nbsp;:‘,&nbsp;s.size,&nbsp;‘bytes‘
print&nbsp;‘Packed&nbsp;Value&nbsp;:‘,&nbsp;binascii.hexlify(packed_data)
print&nbsp;‘Unpacked&nbsp;Type&nbsp;:‘,&nbsp;type(unpacked_data),&nbsp;‘&nbsp;Value:‘,&nbsp;unpacked_data

#输出
Original&nbsp;values:&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.7)&nbsp;
Format&nbsp;string&nbsp;:&nbsp;I3sf&nbsp;Uses&nbsp;:&nbsp;12&nbsp;bytes&nbsp;
Packed&nbsp;Value&nbsp;:&nbsp;0100000061626300cdcc2c40&nbsp;
Unpacked&nbsp;Type&nbsp;:&nbsp;&lt;type&nbsp;‘tuple‘&gt;&nbsp;&nbsp;Value:&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.700000047683716)</pre>
<p>代码中，首先定义了一个元组数据，包含int、string、float三种数据类型，然后定义了struct对象，并制定了format‘I3sf’，I 表示int，3s表示三个字符长度的字符串，f 表示 float。最后通过struct的pack和unpack进行打包和解包。通过输出结果可以发现，value被pack之后，转化为了一段二进制字节串，而unpack可以把该字节串再转换回一个元组，但是值得注意的是对于float的精度发生了改变，这是由一些比如操作系统等客观因素所决定的。打包之后的数据所占用的字节数与C语言中的struct十分相似。定义format可以参照官方api提供的对照表：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvODMvRkQvd0tpb0wxZURFQmJnREpjT0FBRFplSWVBTVVJMzIzLnBuZw==.jpg" /></p>
<p><strong>2、 字节顺序</strong></p>
<p>另一方面，打包的后的字节顺序默认上是由操作系统的决定的，当然struct模块也提供了自定义字节顺序的功能，可以指定大端存储、小端存储等特定的字节顺序，对于底层通信的字节顺序是十分重要的，不同的字节顺序和存储方式也会导致字节大小的不同。在format字符串前面加上特定的符号即可以表示不同的字节顺序存储方式，例如采用小端存储 s = struct.Struct(‘<strong>&lt;</strong>I3sf’)就可以了。官方api library 也提供了相应的对照列表：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvODMvRkUvd0tpb20xZURFREdUVWlzcEFBQm1VYW4wUldnNTAzLnBuZw==.jpg" /></p>
<p><strong>3、利用buffer，使用pack_into和unpack_from方法</strong></p>
<p>使用二进制打包数据的场景大部分都是对性能要求比较高的使用环境。而在上面提到的pack方法都是对输入数据进行操作后重新创建了一个内存空间用于返回，也就是说我们每次pack都会在内存中分配出相应的内存资源，这有时是一种很大的性能浪费。struct模块还提供了pack_into() 和 unpack_from()的方法用来解决这样的问题，也就是对一个已经提前分配好的buffer进行字节的填充，而不会每次都产生一个新对象对字节进行存储。</p>
<pre>import&nbsp;struct
import&nbsp;binascii
import&nbsp;ctypes
values&nbsp;=&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.7)
s&nbsp;=&nbsp;struct.Struct(‘I3sf‘)
prebuffer&nbsp;=&nbsp;ctypes.create_string_buffer(s.size)
print&nbsp;‘Before&nbsp;:‘,binascii.hexlify(prebuffer)
s.pack_into(prebuffer,0,*values)
print&nbsp;‘After&nbsp;pack:‘,binascii.hexlify(prebuffer)
unpacked&nbsp;=&nbsp;s.unpack_from(prebuffer,0)
print&nbsp;‘After&nbsp;unpack:‘,unpacked

#输出
Before&nbsp;:&nbsp;000000000000000000000000&nbsp;
After&nbsp;pack:&nbsp;0100000061626300cdcc2c40&nbsp;
After&nbsp;unpack:&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.700000047683716)</pre>
<p>对比使用pack方法打包，pack_into 方法一直是在对prebuffer对象进行操作，没有产生多余的内存浪费。另外需要注意的一点是，pack_into和unpack_from方法均是对string buffer对象进行操作，并提供了offset参数，用户可以通过指定相应的offset，使相应的处理变得更加灵活。例如，我们可以把多个对象pack到一个buffer里面，然后通过指定不同的offset进行unpack：</p>
<pre>import&nbsp;struct
import&nbsp;binascii
import&nbsp;ctypes
values1&nbsp;=&nbsp;(1,&nbsp;‘abc‘,&nbsp;2.7)
values2&nbsp;=&nbsp;(‘defg‘,101)
s1&nbsp;=&nbsp;struct.Struct(‘I3sf‘)
s2&nbsp;=&nbsp;struct.Struct(‘4sI‘)
prebuffer&nbsp;=&nbsp;ctypes.create_string_buffer(s1.size+s2.size)
print&nbsp;‘Before&nbsp;:‘,binascii.hexlify(prebuffer)
s1.pack_into(prebuffer,0,*values1)
s2.pack_into(prebuffer,s1.size,*values2)
print&nbsp;‘After&nbsp;pack:‘,binascii.hexlify(prebuffer)
print&nbsp;s1.unpack_from(prebuffer,0)
print&nbsp;s2.unpack_from(prebuffer,s1.size)

#输出
Before&nbsp;:&nbsp;0000000000000000000000000000000000000000&nbsp;
After&nbsp;pack:&nbsp;0100000061626300cdcc2c406465666765000000&nbsp;
(1,&nbsp;‘abc‘,&nbsp;2.700000047683716)&nbsp;
(‘defg‘,&nbsp;101)</pre>
<p><strong><br /></strong></p>
<p><strong>4、struct.calcsize方法</strong></p>
<p>struct.calcsize用于计算格式字符串所对应的结果的长度，如：struct.calcsize(‘ii‘)，返回8。因为两个int类型所占用的长度是8个字节。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-14 02:41:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/python/" title="python">python</a>, <a href="https://www.biecuoliao.com/tag/%e4%ba%8c%e8%bf%9b%e5%88%b6/" title="二进制">二进制</a>, <a href="https://www.biecuoliao.com/tag/%e5%ad%97%e7%ac%a6%e4%b8%b2/" title="字符串">字符串</a>, <a href="https://www.biecuoliao.com/tag/%e7%bb%93%e6%9e%84%e4%bd%93/" title="结构体">结构体</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>python struct模块的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pKa23.html" rel="bookmark">python中struct模块及packet和unpacket</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://www.cnblogs.com/gala/archive/2011/09/22/2184801.html 我们知道python只定义了6种数据类型,字符串,整数,浮点数,列表,元组,字典.但是C语言中有些字节型的变量,在python中该如何实现呢?这点颇为重要,特别是要在网络上进行数据传输的话. 有的时候需要用python处理二进制数据,比如,存取文件,socket操作时.这时候,可以使用python的struct模块来完成.可以用 struct来处理c语言中的结构体. st			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ayqNP0.html" rel="bookmark">python中struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转:  http://www.cnblogs.com/coser/archive/2011/12/17/2291160.html 最近在学习python网络编程这一块,在写简单的socket通信代码时,遇到了struct这个模块的使用,当时不太清楚这到底有和作用,后来查阅了相关资料大概了解了,在这里做一下简单的总结. 了解c语言的人,一定会知道struct结构体在c语言中的作用,它定义了一种结构,里面包含不同类型的数据(int,char,bool等等),方便对 某一结构对象进行处理.而在网络通信			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rxVWbM.html" rel="bookmark">浅析Python中的struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在学习python网络编程这一块,在写简单的socket通信代码时,遇到了struct这个模块的使用,当时不太清楚这到底有和作用,后来查阅了相关资料大概了解了,在这里做一下简单的总结. 了解c语言的人,一定会知道struct结构体在c语言中的作用,它定义了一种结构,里面包含不同类型的数据(int,char,bool等等),方便对某一结构对象进行处理.而在网络通信当中,大多传递的数据是以二进制流(binary data)存在的.当传递字符串时,不必担心太多的问题,而当传递诸如int.char之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jgA1V3.html" rel="bookmark">Python标准库笔记&lpar;6&rpar; &mdash; struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				该模块作用是完成Python数值和C语言结构体的Python字符串形式间的转换.这可以用于处理存储在文件中或从网络连接中存储的二进制数据,以及其他数据源. 用途: 在Python基本数据类型和二进制数据之间进行转换 struct模块提供了用于在字节字符串和Python原生数据类型之间转换函数,比如数字和字符串. 模块函数和Struct类 它除了提供一个Struct类之外,还有许多模块级的函数用于处理结构化的值.这里有个格式符(Format specifiers)的概念,是指从字符串格式转换为已编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R95L7M.html" rel="bookmark">Python：struct模块的pack、unpack</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mport struct pack.unpack.pack_into.unpack_from 1 # ref: http://blog.csdn&lt;a href=&quot;http://lib.csdn.net/base/dotnet&quot; class='replace_word' title=&quot;.NET知识库&quot; target='_blank' style='color:#df3434; font-weight:bold;'&gt;.NET&lt;/a&gt;/JGood/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV6ewkM.html" rel="bookmark">Python学习&mdash;&mdash;struct模块的pack unpack示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				import struct pack.unpack.pack_into.unpack_from # ref: http://blog.csdn.net/JGood/archive/2009/06/22/4290158.aspx import struct #pack - unpack print print '===== pack - unpack =====' str = struct.pack(&quot;ii&quot;, 20, 400) print 'str:', str print 'len(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3w1akQM.html" rel="bookmark">python的struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python中缺少类似C语言structs这样直接对字节序列进行序列化和反序列化的语法,作为一门脚本语言这是不必要的,但作为一门完整的编程语言必须提供这样的能力,否则不能独立的处理二进制文件和数据流.struct模块即为处理这类问题而诞生. 要处理字节序需要三个能力:首先是字节和变量值的互相转化,其次是字节序序问题,最后是数据对其的处理. python中的基本变量类型有限,分别为int,float,bool类型.并且根据不同的运行环境所占用的长度不确定,这点跟C语言完全没法比.因此模块中我们需要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qd7XN3.html" rel="bookmark">python模块之subprocess模块&comma; struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				subprocess import subprocess ''' sh-3.2# ls /Users/egon/Desktop |grep txt$ mysql.txt tt.txt 事物.txt ''' res1=subprocess.Popen('ls /Users/jieli/Desktop',shell=True,stdout=subprocess.PIPE) res=subprocess.Popen('grep txt$',shell=True,stdin=res1.stdout, s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmK9G13.html" rel="bookmark">Python之路&mdash;&mdash;struct模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				struct模块 # struct 模块 用来将数字字符串等转换成固定长度的字节 # format: # x: pad byte (no data); c:char; b:signed byte; B:unsigned byte; # ?: _Bool (requires C99; if not available, char is used instead) # h:short; H:unsigned short; i:int; I:unsigned int; # l:long; L:unsi			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPlk1M.html" rel="bookmark" class="title">C&num;系统硬件类列表</a>
					<div>
						1 WMI CLASS 2 3 // 硬件 4 Win32_Processor, // CPU 处理器 5 Win32_PhysicalMemory, // 物理内存条 6 Win32_Keyboar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGOAB3.html" rel="bookmark" class="title">C&num; url转义字符</a>
					<div>
						在web开发中通过(?)方式在浏览器地址栏传值时,浏览器是通过“&amp;”来区分参数个数及取值的,比如: http://localhost/default.aspx?param1=10&amp;5  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awDLE4.html" rel="bookmark" class="title">rancher api key</a>
					<div>
						rancher将docker容器的界面化做的很好了,但是我们有时间需要在别的地方查看容器的一些信息,怎么办呢? rancher自己提供的有api 点击api查看 我们能够查看到该容器的一些信息,实际上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mglDM.html" rel="bookmark" class="title">穹举，迭代，while循环。</a>
					<div>
						所有循环  必要条件 :   初始条件(注意初始条件的位置)   循环条件   循环体   状态改变: 1.穷举 将所有可能性全部全部走一遍,使用IF筛选出满足的情况 使用循环语句    for    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4peKkgM.html" rel="bookmark" class="title">马哥教育面授班-标准I&sol;O和管道-课后小作业-2016年7月28</a>
					<div>
						马哥教育面授班-7月28号作业 1 .将/etc/issue 文件中的内容转换为大写后保存至/tmp/issue.out 文件中 [[email protected] ~]# tr 'a-z' 'A- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGk9w4.html" rel="bookmark" class="title">CSS3中的opacity透明度属性的继承问题如何解决</a>
					<div>
						利用CSS3的透明属性opacity可以为我们创建对象的渐隐渐显的动画效果,但是很多情况下这种单一的渐隐渐显效果并不能满足我们的日常开发需求.有时候,我们需要在设置opacity属性的对象里面增加其子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEqDw0.html" rel="bookmark" class="title">关于dll的路径问题</a>
					<div>
						最近在做一个sdk二次开发的项目,具体是将一个C++开发的SDk用C#将它的API接口全部封装一遍,然后再做一个demo就好了 好不容易封装完了,在使用的时候出了问题.原来SDK中的dll老是加载不到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGKQbM.html" rel="bookmark" class="title">解决从Windows拷贝来的文件到Ubuntu出现乱码的问题</a>
					<div>
						1.转换文件内容编码    Windows下天生的纯文本文件,其中文编码为GBK,在Ubuntu下显示为乱码,可以使用iconv命令进行转换:    iconv -f gbk -t utf8 sour ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaRdV3.html" rel="bookmark" class="title">C&num;无标题窗体的拖动</a>
					<div>
						using System; using System.Drawing; using System.Collections; using System.ComponentModel; using Sys ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BNjJM.html" rel="bookmark" class="title">React-Native 告别CodePush，自建热更新版本升级环境</a>
					<div>
						微软的CodePush热更新非常难用大家都知道,速度跟被墙了没什么区别. 另外一方面,我们不希望把代码放到别人的服务器.自己写接口更新总归感觉安全一点. so,就来自己搞个React-Native A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRE8w3.html" rel="bookmark" class="title">在两个进程间通信</a>
					<div>
						进程1的数据有时需要发送给进程B,这可以通过内存映射实现. 主要用到的函数: 1.首先在一个进程里用CreateFileMapping创建一个新的文件映射内核对象. HANDLE CreateFile ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moazrw3.html" rel="bookmark" class="title">python入门基础教程04 Python程序基本组成</a>
					<div>
						Python程序基本组成 Python和其他高级语言一样,几乎都是首先从某些地方接收一些数据(如键盘或文件或者赋值),接着对数据进行必要的处理,之后把处理的结果传到某个地方去(输出到文件.数据库或者打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZ6GP0.html" rel="bookmark" class="title">JavaEE基础（四）</a>
					<div>
						1.Java语言基础(循环结构概述和for语句的格式及其使用) A:循环结构的分类 for,while,do...while B:循环结构for语句的格式: for(初始化表达式;条件表达式;循环后的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRjWA3.html" rel="bookmark" class="title">实习进度记录</a>
					<div>
						第一天实习:组件开发初探 我的第一个实习任务,是基于DWR和JDIY等轻量级工具,进行针对某一特定功能的组件的开发. 接到leader下发的项目原型图以及数据库模型,回去后自学了PowerDesign ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWGay0.html" rel="bookmark" class="title">杂题 UVAoj 107 The Cat in the Hat</a>
					<div>
						 The Cat in the Hat  Background (An homage to Theodore Seuss Geisel) The Cat in the Hat is a nasty c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezQmw3.html" rel="bookmark" class="title">《C&plus;&plus;编程艺术》第五章 下载工具源码</a>
					<div>
						今天看了书上的第五章代码,看了后想编译起来结果报了好些错,修改完后已经可以正确的编译起来,供大家下载研究 // Header file for downloader. Call this file d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9KvDM.html" rel="bookmark" class="title">Oracle11g温习-第十八章：role管理</a>
					<div>
						2013年4月27日 星期六 10:52 role 的功能:简化用户的权限管理 建立角色--给角色授权--将角色授予用户/角色 2.查看系统建立的role SYS @ prod &gt;  selec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41elEk4.html" rel="bookmark" class="title">ajax提交java后台接收参数出现乱码</a>
					<div>
						1.现象: 前台ajax提交查询数据 $.ajax({ url: 'bdmap/xx.action', data:para, dataType:'json', contentType:&quot;ap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pGvZx3.html" rel="bookmark" class="title">JAVA多线程（六）模式-Balking</a>
					<div>
						Balking 多线程共享一个资源,该资源发现无法提供服务则拒绝接受请求,请求将失败而不是继续等待资源. 适用环境 对共享资源的请求是可被拒绝.不需要等待的. 样例 秒杀. 只有一定数量的商品,超出数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0agRmn4.html" rel="bookmark" class="title">《软件测试》 第五次博客作业</a>
					<div>
						我们学习了很多的专业课程,像编程语言.算法.数据结构.编译原理.软件工程等.我想大家都会有这样的疑问:我学了这么多的课程有什么用呢?在工作中有多少会真正被应用到呢?也就是说,大家都觉得理论和实践之间有 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
